// Contact.h: interface for the CContact class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONTACT_H__804AF4F1_ECC6_4115_9D26_B17214477701__INCLUDED_)
#define AFX_CONTACT_H__804AF4F1_ECC6_4115_9D26_B17214477701__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ipclass.h"

#define CFL_OFFLINE			0x01
#define CFL_ONLINE			0x02
#define CFL_AWAY			0x04
#define CFL_AUTHENTICATE_NO 0x08
#define CFL_BLOCKED			0x10
#define CFL_ACTIVE			0x20
#define CFL_TRANSFER		0x40
#define CFL_DLGCREATED		0x80

class CConversationThread;
class CNetSocket;
class CContactView;
class CFileSocketThread;

typedef struct {
	LOGFONT lfFont;
	COLORREF crColor;
	int nPointSize;
} USERFONT;

class CContact  
{
public:
	CContact();
	virtual ~CContact();
	IP GetHostName();
	CString GetScreenName();
	CString GetAwayReason();
	CString GetTruncatedScreenName(int len);
	void SetScreenName(const char *);
	void SetAwayReason(const char *);
	void SetHost(IP host);
	CNetSocket* GetSock();
	void SetSock(CNetSocket *Socket);
	long Flags;
	int ListItem;
	void SignOffline();
	void ShowOnline();
	void ShowOffline();

	BOOL IsOffline() { return (Flags & CFL_OFFLINE); }
	BOOL IsOnline() { return (Flags & CFL_ONLINE); }
	BOOL IsConvWindowOpen() { return (Flags & CFL_DLGCREATED); }
	BOOL IsAway() { return Flags & CFL_AWAY; }
	BOOL IsBlocked() { return Flags & CFL_BLOCKED; }
	BOOL IsTransfering() { return Flags & CFL_TRANSFER; }

	void SetBlocked(bool Block, HWND);
	void SetAway(bool bAway, char *Reason);
	CConversationThread *pThread;
	bool Attempted;
	bool WeConnected;
	bool NextInvalid;
	CFileSocketThread *Transfer;
	USERFONT uFont;
private:
	IP HostName;
	CNetSocket* ClientSocket;
	CString ScreenName;
	CString AwayReason;
};

#endif // !defined(AFX_CONTACT_H__804AF4F1_ECC6_4115_9D26_B17214477701__INCLUDED_)
