// Conversation.cpp : implementation file
//

#include "stdafx.h"
#include "Netmsg.h"
#include "Conversation.h"
#include "Contact.h"
#include "ContactView.h"
#include "FileSend.h"
#include "ConvEdit.h"
#include "ResolverThread.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//The conversation dialog 

#define CHECK_WND(x) if (!::IsWindow(x.m_hWnd)) return;
#define CHECK_WND_P(x) if (!::IsWindow(x->m_hWnd)) return;
#define CHECK_WND_P0(x) if (!::IsWindow(x->m_hWnd)) return 0;
#define CHECK_WND0(x) if (!::IsWindow(x.m_hWnd)) return 0;


CConversation::CConversation(CWnd* pParent, CContact *With, char *DefaultMsg)
	: CDialog(CConversation::IDD, pParent)
{
	pszDefaultMessage = DefaultMsg;
	Contact = With;

	BrushWhite.CreateSolidBrush(RGB(255, 255, 255)); 
	BrushNormal.CreateSolidBrush(GetColor(COL_LINEFRAMES));
	BrushLight.CreateSolidBrush(GetColor(COL_LIGHTITEMS));
	BrushDisabled.CreateSolidBrush(GetColor(COL_DISABLED));

	FontBold.CreateFont(13, 0, 0, 0, FW_BOLD, 0, 0, 0, 0, 0, 0, 0, 0, "Tahoma");
	FontNormal.CreateFont(13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Tahoma");

	m_iSendFile = AfxGetApp()->LoadIcon(IDI_SENDFILE);
	m_iSendFileD = AfxGetApp()->LoadIcon(IDI_SENDFILED);
	m_iBlock = AfxGetApp()->LoadIcon(IDI_BLOCK);
	m_iUnblock = AfxGetApp()->LoadIcon(IDI_UNBLOCK);

	HasMessage = false;
	Enabled = true;
	IsTransfering = false;

	//{{AFX_DATA_INIT(CConversation)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	memset(&ufFontNormal, 0, sizeof(USERFONT));

	ufFontNormal.lfFont.lfHeight = 16;
	ufFontNormal.lfFont.lfWeight = FW_NORMAL;
	ufFontNormal.lfFont.lfQuality = 1;
	strcpy(ufFontNormal.lfFont.lfFaceName, "MS Sans Serif");
	ufFontNormal.nPointSize = 100;
	ufFontNormal.crColor = RGB(0, 0, 0);

	m_SplitterPos = 0;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_CONVERSATION);
}

CConversation::~CConversation()
{
	::FreeResource(m_iSendFile);
	::FreeResource(m_iSendFileD);
	::FreeResource(m_iBlock);
	::FreeResource(m_iUnblock);
	::FreeResource(m_hIcon);
}


void CConversation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConversation)
	DDX_Control(pDX, IDC_CANCEL, m_Cancel);
	DDX_Control(pDX, IDC_SENDFILE, m_SendFile);
	DDX_Control(pDX, IDC_BLOCK, m_Block);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConversation, CDialog)
	//{{AFX_MSG_MAP(CConversation)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_SENDMSG, OnChangeSendmsg)
	ON_COMMAND(ID_IDRCONVERSATIONMENU_BLOCK, OnIdrconversationmenuBlock)
	ON_COMMAND(ID_IDRCONVERSATIONMENU_SENDFILE, OnIdrconversationmenuSendfile)
	ON_WM_CTLCOLOR()
	ON_COMMAND(ID_IDRCONVERSATIONMENU_CHANGEFONT, OnIdrconversationmenuChangefont)
	ON_WM_GETMINMAXINFO()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_BN_CLICKED(IDC_BLOCK, OnBlock)
	ON_BN_CLICKED(IDC_SENDFILE, OnSendfile)
	ON_BN_CLICKED(IDC_CANCEL, OnTransferCancel)
	ON_COMMAND(ID_ACTIONS_CHOOSEADVANCEDCOLOR, OnActionsChooseadvancedcolor)
	ON_BN_CLICKED(IDC_SENDBUTTON, OnSend)
	ON_MESSAGE(WM_RECEIVEDMESSAGE, ReceivedMessage)
	ON_MESSAGE(WM_TYPENOTIFY, OnTypeNotify)
	ON_COMMAND(ID_HELP_EMOTICONSHELP, OnHelpEmoticonshelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConversation message handlers

void CConversation::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	UpdateSizes();
	RedrawEssential();
}

static UINT auIDStatusBar[] = {
	ID_SEPARATOR
};

BOOL CConversation::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CenterWindow(GetDesktopWindow());

	CRect rcClientRect;
	CRect rcEmptyRect;

	GetClientRect(rcClientRect);

	rcEmptyRect.SetRectEmpty();

	m_bgWnd.Create(NULL, NULL, WS_VISIBLE | WS_CHILD, rcEmptyRect, this, 10021);

	m_Chat.CreateEx((OSVER & WIN_WINNT && GetApp()->View->bmConvBack)
		? WS_EX_TRANSPARENT : 0, NULL, NULL, WS_VISIBLE | WS_CHILD |
					WS_CLIPCHILDREN | WS_VSCROLL | ES_MULTILINE | ES_READONLY |
					ES_AUTOVSCROLL | ES_LEFT | ES_WANTRETURN, rcEmptyRect, &m_bgWnd, IDC_CHAT, NULL, this);

	m_bgWnd.m_Chat = &m_Chat;

	m_SendMsg.Create(NULL, NULL, WS_VISIBLE | WS_CHILD |
					WS_CLIPCHILDREN | WS_VSCROLL | ES_MULTILINE | WS_TABSTOP |
					ES_AUTOVSCROLL | ES_LEFT | ES_WANTRETURN, rcEmptyRect, this, IDC_SENDMSG, NULL, this);
	m_Chat.AutoURLDetect(true);
	m_Chat.SetEventMask(m_Chat.GetEventMask() | ENM_LINK);

	m_SendMsg.LimitText(500);

	if (m_statusBar.Create(this))
	{
		m_statusBar.SetIndicators(auIDStatusBar, sizeof(auIDStatusBar) / sizeof(unsigned int));

		m_statusBar.SetPaneInfo(0, m_statusBar.GetItemID(0),
			SBPS_STRETCH, NULL );
	}

	CRect rcClientStart;
	CRect rcClientNow;
	GetClientRect(rcClientStart);

	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST,
				   0, reposQuery, rcClientNow);
	CPoint ptOffset(rcClientNow.left - rcClientStart.left,
					rcClientNow.top - rcClientStart.top);

	CRect  rcChild;
	CWnd* pwndChild = GetWindow(GW_CHILD);

	while (pwndChild)
	{
		pwndChild->GetWindowRect(rcChild);
		ScreenToClient(rcChild);
		rcChild.OffsetRect(ptOffset);
		pwndChild->MoveWindow(rcChild, FALSE);
		pwndChild = pwndChild->GetNextWindow();
	}

	Font.CreateFontIndirect(&GetApp()->View->Me.uFont.lfFont);

	CRect rcWindow;
	GetWindowRect(rcWindow);

	rcWindow.right += rcClientStart.Width() - rcClientNow.Width();
	rcWindow.bottom += rcClientStart.Height() - rcClientNow.Height();

	MoveWindow(rcWindow, FALSE);

	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	SetIcon(m_hIcon, TRUE);         // Set big icon
	SetIcon(m_hIcon, FALSE);        // Set small icon

	m_Chat.AppendWindowTextF(&ufFontNormal, 0, 
		AfxGetApp()->GetProfileString("Settings", "SecurityWarning", 
		"(M) Netmsg 1.2.2.0$CRLF $UL$CRLF"));

	CString cstr;

	if (pszDefaultMessage)
	{
		ReceivedMessage(0, (LPARAM)pszDefaultMessage);
	}

	cstr.Format("Conversation: %s", Contact->GetScreenName());

	SetWindowText(cstr);

	// position controls //

	m_SendButton.SubclassDlgItem(IDC_SENDBUTTON, this);
	m_SendButton.SetTextAlignment(CMSNButton::AlignCenter);
	m_SendButton.SetFont(&FontNormal);
	m_SendButton.EnableWindow(FALSE);
	m_SendButton.SetCornerColor(RGB(255, 255, 255));

	m_Message.Create("", WS_CHILD, rcEmptyRect, this);
	m_Message.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));
	m_Message.SetFont(&FontNormal);

	m_To.Create("", WS_CHILD | SS_ENDELLIPSIS, rcEmptyRect, this);
	m_To.SetColors(GetColor(COL_NOTIFYTEXT), GetColor(COL_LINEFRAMES));
	m_To.ShowWindow(SW_SHOW);
	m_To.SetFont(&FontBold);

	m_Splitter.Create(NULL, WS_CHILD | SS_NOTIFY, rcEmptyRect, this, IDC_STATIC);
	m_Splitter.ShowWindow(SW_SHOW);

	// file transfer controls //

	m_Progress.Create(WS_CHILD, rcEmptyRect, this, 0xFFFF);
	m_Progress.SetGradientColors(RGB(171, 190, 239), RGB(88, 125, 222));
	m_Progress.SetBkColor(GetColor(COL_LIGHTITEMS));
	m_Progress.SetRubberBar(TRUE);
	m_Progress.SetTextFormat("%d%%", PBS_SHOW_PERCENT);
	m_Progress.SetFont(&FontNormal);
	m_Progress.SetTextColor(GetColor(COL_NORMALTEXT));

	m_FileStats.Create(NULL, WS_CHILD, rcEmptyRect, this, IDC_STATIC);
	m_TransferStats.Create(NULL, WS_CHILD, rcEmptyRect, this, IDC_STATIC);
	m_FileStats.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));
	m_TransferStats.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));
	m_TransferStats.SetFont(&FontNormal);
	m_FileStats.SetFont(&FontNormal);

	////////////////////////////

	m_SendMsg.SetFont(&Font);
	m_Block.SetTextAlignment(CTrackLookButton::AlignRight);
	m_Block.SetIcons(m_iBlock);
	m_Block.SetIconSize(24, 24);
	m_Block.SetWindowText("Block");
	m_SendFile.SetIcons(m_iSendFile, m_iSendFile, m_iSendFileD);
	m_SendFile.SetWindowText("Send File");
	m_SendFile.SetTextAlignment(CTrackLookButton::AlignRight);
	m_SendFile.SetIconSize(24, 24);

	m_SendButton.MoveWindow(rcClientRect.right - 60, rcClientRect.bottom - 72, 52, 45);
	m_To.MoveWindow(6, 4, rcClientRect.right - 6, 18);
	m_Block.MoveWindow(rcClientRect.right - 84, rcClientRect.bottom - 116, 80, 34);
	m_SendFile.MoveWindow(rcClientRect.right - 169, rcClientRect.bottom - 116, 85, 34);

	strcpy(Host, "Resolving host name...");

	char buf[512];

	sprintf(buf, "To: %s (%s) Resolving host name...", 
		Contact->GetTruncatedScreenName(32), Contact->GetHostName().Get());
	m_To.SetWindowText(buf);

	CResolverThread *Thread = new CResolverThread(Contact->GetHostName(), this);
	Thread->CreateThread();

	WINDOWPLACEMENT *wpl;
	unsigned int sz = sizeof(WINDOWPLACEMENT);

	if (AfxGetApp()->GetProfileBinary("Settings", "WindowPosChat", (LPBYTE *)&wpl, &sz))
	{
		SetWindowPlacement(wpl);
	}

	delete wpl;

	UpdateWindow();

	m_Block.Invalidate();

	SetSplitterPos(AfxGetApp()->GetProfileInt("Settings", "SplitterPos", 0));

	SetTimer(1, 1, 0);
	UpdateSizes();

	Contact->Flags |= CFL_DLGCREATED;
	//NOW we're active :P

	return TRUE;
}


void CConversation::OnSend() 
{
	MESSAGE *Msg = new MESSAGE;
	m_SendMsg.GetWindowText(Msg->Message, m_SendMsg.GetWindowTextLength() + 1);

	if (!strcmp(Msg->Message, "\r\n"))
	{
		m_SendMsg.SetWindowText("");
		return;
	}

	if (!stricmp(Msg->Message, ""))
	{
		m_SendMsg.SetFocus();
		return;
	}
	else
	{
		char buf[1024];
		strcpy(buf, Msg->Message);
		Msg->To = Contact;
		Msg->CallingDialog = this;

		PluginsMessageSent(Msg->To, buf);

		ReceivedMessage(1, (LPARAM) nstrdup(buf));

		strcpy(Msg->Message, buf);

		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_SENDTHISMESSAGE, 0, (LPARAM) Msg);
	}
	m_SendMsg.SetFocus();
	m_SendMsg.SetWindowText("");
	OnChangeSendmsg();
}

void CConversation::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{
	case 1:
		m_SendMsg.SetFocus();
		KillTimer(1);
		break;
	case 2:
		m_Chat.SetFocus();
		KillTimer(2);
		break;
	case 3:
		RedrawWindow();
		KillTimer(3); 
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CConversation::OnChangeSendmsg() 
{
	static bool Sent = true;
	char buf[512];

	m_SendMsg.GetWindowText(buf, sizeof(buf));

	if (!stricmp(buf, ""))
	{
		RECT rect;
		GetClientRect(&rect);
		rect.top = rect.bottom - 90;
		rect.right = 20;
		rect.bottom = rect.top + 40;
		RedrawWindow(&rect);
		m_SendButton.EnableWindow(FALSE);
	}
	else
	{
		m_SendButton.EnableWindow(TRUE);
	}
	if (!Sent && !stricmp(buf, ""))
	{
		if (Contact->IsOffline()) return;
		Sent = true;
		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_TYPENOTIFY, 0, (LPARAM) Contact);
	}
	else if (Sent && stricmp(buf, ""))
	{
		if (Contact->IsOffline()) return;

		Sent = false;
		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_TYPENOTIFY, 1, (LPARAM) Contact);
	}

}

void CConversation::OnIdrconversationmenuBlock() 
{
	if (Contact->IsBlocked())
	::SendMessage(GetApp()->View->GetSafeHwnd(), WM_BLOCKTHISCONTACT, 0, (LPARAM) Contact); 	
	else
	{
		if (Contact->IsTransfering())
		{
			MessageBox("You cannot block a contact with a file transfer in progress", "Block contact", MB_OK|MB_ICONSTOP);
			return;
		}
		else
		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_BLOCKTHISCONTACT, 1, (LPARAM) Contact); 	
	}
}

void CConversation::OnIdrconversationmenuSendfile() 
{
	GetApp()->View->StartFileTransfer(GetSafeHwnd(), Contact, true);
}

void CConversation::FileDropped(char *FileName, unsigned int Len)
{
	GetApp()->View->StartFileTransfer(GetSafeHwnd(), Contact, true, FileName);
}

HBRUSH CConversation::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd == this || pWnd == &m_Chat)
	return (HBRUSH) BrushWhite;

	else if (pWnd == &m_SendMsg)
	{
		if (Enabled) return (HBRUSH) BrushWhite;
		else return (HBRUSH) BrushDisabled;
	}
	else if (pWnd == &m_To || pWnd == &m_Splitter)
	return (HBRUSH) BrushNormal;

	else if (pWnd == &m_Message || pWnd == &m_Block || pWnd == &m_SendFile
		|| pWnd == &m_Cancel || pWnd == &m_FileStats || pWnd == &m_TransferStats)
	return (HBRUSH) BrushLight;

	return NULL;
}

void CConversation::OnIdrconversationmenuChangefont() 
{
	CHOOSEFONT cf;
	USERFONT uf;

	memcpy(&uf, &GetApp()->View->Me.uFont, sizeof(USERFONT));

	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = GetSafeHwnd();
	cf.iPointSize = uf.nPointSize;
	cf.lpLogFont = &uf.lfFont;
	cf.hInstance = AfxGetInstanceHandle();
	cf.Flags = CF_INITTOLOGFONTSTRUCT | CF_BOTH;

	Font.DeleteObject();

	ChooseFont(&cf);

	Font.CreateFontIndirect(&uf.lfFont);

	uf.nPointSize = cf.iPointSize;

	memcpy(&GetApp()->View->Me.uFont, &uf, sizeof(USERFONT));

	GetApp()->View->SendMessage(WM_UPDATEMYFONT, 0, 0);

	m_SendMsg.SetFont(&Font);
}

void CConversation::OnActionsChooseadvancedcolor() 
{
	CHOOSECOLOR cc;
	static COLORREF acrCustClr[16];

	ZeroMemory(&cc, sizeof(CHOOSECOLOR));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = GetSafeHwnd();
	cc.lpCustColors = (LPDWORD) acrCustClr;
	cc.rgbResult = GetApp()->View->Me.uFont.crColor;
	cc.Flags = CC_FULLOPEN | CC_RGBINIT;
 
	if (ChooseColor(&cc))
	{
		GetApp()->View->Me.uFont.crColor =  cc.rgbResult;
		GetApp()->View->SendMessage(WM_UPDATEMYFONT, 0, 0);
	}
}

void CConversation::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if (IsTransfering) lpMMI->ptMinTrackSize.y = 289;
	else if (HasMessage) lpMMI->ptMinTrackSize.y = 253;
	else lpMMI->ptMinTrackSize.y = 237;
	if (IsTransfering) lpMMI->ptMinTrackSize.x = 300;
	else lpMMI->ptMinTrackSize.x = 185;

	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CConversation::HostResolved(const char *NewHost)
{
	CHECK_WND_P(this)
	CHECK_WND(m_To)

	char buf[512];
	strcpy(Host, NewHost);
	sprintf(buf, "To: %s (%s) %s", Contact->GetTruncatedScreenName(32), Contact->GetHostName().Get(), NewHost);
	m_To.SetWindowText(buf);
}

void CConversation::ScreenNameChanged(const char *NewName)
{
	char buf[512];

	CHECK_WND_P(this)
	CHECK_WND(m_To)

	sprintf(buf, "Conversation: %s", NewName);
	SetWindowText(buf);
	sprintf(buf, "To: %s (%s) %s", Contact->GetTruncatedScreenName(32), Contact->GetHostName().Get(), Host);
	m_To.SetWindowText(buf);
}

LRESULT CConversation::ReceivedMessage(WPARAM wParam, LPARAM lParam)
{
	CHECK_WND_P0(this)
	CHECK_WND0(m_Chat)

	char *Message = (char *)lParam;


	m_Chat.AppendWindowTextF(&ufFontNormal, 0, "%s says:\r\n", wParam ? 
		GetApp()->View->Me.GetScreenName() : Contact->GetScreenName()); 

	m_Chat.AppendWindowTextF(wParam ? &GetApp()->View->Me.uFont : &Contact->uFont, 200, "%s\r\n", Message);

	PluginsMessageReceived(Contact, Message);

	delete [] Message;

	if (!wParam)
		FlashWindow(TRUE);

	return 0L;
}

LRESULT CConversation::OnTypeNotify(WPARAM wParam, LPARAM lParam)
{
	char buf[512];

	CHECK_WND_P0(this)
	CHECK_WND0(m_statusBar)

	if (wParam)
	{
		sprintf(buf, "%s is typing a message", Contact->GetTruncatedScreenName(32));
		m_statusBar.SetWindowText(buf);
	}
	else
		m_statusBar.SetWindowText("");
	return 0L;
}

void CConversation::OnClose() 
{
	if (IsTransfering)
	if (Thread)
	if (!Thread->Finished)
	{
		MessageBox("You cannot close this window with a transfer in progress", "Close window", MB_OK|MB_ICONSTOP);
		return;
	}

	WINDOWPLACEMENT windowPlacement;
	GetWindowPlacement(&windowPlacement);
	if (windowPlacement.showCmd != SW_SHOWMINIMIZED)
	AfxGetApp()->WriteProfileBinary("Settings", "WindowPosChat", (BYTE*)&windowPlacement, sizeof(WINDOWPLACEMENT));		
	AfxGetApp()->WriteProfileInt("Settings", "SplitterPos", m_SplitterPos);
	EndDialog(IDOK);
}

void CConversation::ShowMessage(const char *Text)
{
	if (IsTransfering) return;

	CHECK_WND(m_Message)
	CHECK_WND(m_Chat)

	HasMessage = true;
	m_Message.SetWindowText(Text);
	m_Message.ShowWindow(SW_SHOW);

	RECT rect;
	GetWindowRect(&rect);
	if (rect.bottom - rect.top < 253)
	{
		MoveWindow(rect.left, rect.top, rect.right - rect.left, 253);
		SetSplitterPos(0);
	}

	UpdateSizes();
	RedrawEssential();
}

void CConversation::HideMessage()
{
	if (IsTransfering) return;

	CHECK_WND(m_Message)
	CHECK_WND(m_Chat)

	HasMessage = false;
	m_Message.SetWindowText("");
	m_Message.ShowWindow(SW_HIDE);
	UpdateSizes();
	RedrawEssential();
}

void CConversation::Disable()
{
	CHECK_WND(m_SendMsg)
	CHECK_WND(m_SendButton)

	Enabled = false;
	m_SendMsg.Enable(false);
	m_SendButton.SetCornerColor(GetColor(COL_DISABLED));
	m_SendButton.EnableWindow(FALSE);
	SendMessage(WM_PAINT, 0, 0);
	SetNoSend(true);
	SetTimer(2, 1, 0);
	RedrawEssential();
}

void CConversation::Enable()
{
	CHECK_WND(m_SendMsg)
	CHECK_WND(m_SendButton)

	Enabled = true;
	m_SendMsg.Enable(true);
	m_SendButton.SetCornerColor(RGB(255, 255, 255));
	SendMessage(WM_PAINT, 0, 0);
	SetNoSend(false);
	OnChangeSendmsg();
	RedrawEssential();
}

void CConversation::SplitterMoved(int pos)
{
	RECT rect;
	RECT clientRect;
	RECT chatRect;
	POINT cur, point;
	int NewPos = 0;

	GetClientRect(&clientRect);
	GetCursorPos(&cur);
	GetWindowRect(&rect);

	m_bgWnd.GetClientRect(&chatRect);

	point.x = cur.x - rect.right;
	point.y = cur.y - rect.top;
	
	NewPos = point.y - (clientRect.bottom - 82);
	NewPos = -NewPos + 48;

	if (NewPos >= 0 && chatRect.bottom > 40)
	SetSplitterPos(NewPos);
	
	else if (NewPos < m_SplitterPos && NewPos >= 0)
	SetSplitterPos(NewPos);
	
	else if (NewPos < 0)
	{
		if (!m_SplitterPos) return;
		SetSplitterPos(0);
	}
}

void CConversation::SetSplitterPos(int pos)
{
	RECT clientRect;
	RECT rectUpdate;
	GetClientRect(&clientRect);

	m_SplitterPos = pos;
	
	UpdateSizes();

	rectUpdate.left = 0;
	rectUpdate.right = clientRect.right;
	rectUpdate.top = 40;
	rectUpdate.bottom = clientRect.bottom - 30;

	RedrawWindow(&rectUpdate);
}

void CConversation::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	RECT rect;
	GetClientRect(&rect);

	dc.FillSolidRect(0, 0, rect.right, 4, GetColor(COL_LINEFRAMES)); //top
	dc.FillSolidRect(0, 4, 6, 18, GetColor(COL_LINEFRAMES)); //padding before IP static
	dc.FillSolidRect(0, 28, 4, rect.bottom - 56, GetColor(COL_LINEFRAMES)); //left side
	dc.FillSolidRect(rect.right - 4, 28, 4, rect.bottom - 56, GetColor(COL_LINEFRAMES));//right side
	dc.FillSolidRect(10, rect.bottom - 22, rect.right - 20, 4, GetColor(COL_LINEFRAMES));//bottom

	dc.FillSolidRect(4, (rect.bottom - 116) - m_SplitterPos, rect.right - 8, 34, GetColor(COL_LIGHTITEMS)); //light blue bar

	if (HasMessage)
	{
		dc.FillSolidRect(10, 22, rect.right - 20, 6, GetColor(COL_LIGHTITEMS));
		dc.FillSolidRect(4, 28, 6, 18, GetColor(COL_LIGHTITEMS));
		dc.FillSolidRect(rect.right - 10, 28, 6, 18, GetColor(COL_LIGHTITEMS));
	}

	if (IsTransfering)
	{
		dc.FillSolidRect(10, 22, rect.right - 20, 6, GetColor(COL_LIGHTITEMS));
		dc.FillSolidRect(4, 28, rect.right - 8, 54, GetColor(COL_LIGHTITEMS));
		m_Progress.Invalidate();
	}

	if (!Enabled)
	{
		dc.FillSolidRect(rect.right - 8, rect.bottom - 78 - m_SplitterPos, 4, 50 + m_SplitterPos, GetColor(COL_DISABLED));
		dc.FillSolidRect(rect.right - 67, rect.bottom - 78 - m_SplitterPos, 59, 6, GetColor(COL_DISABLED));
		dc.FillSolidRect(rect.right - 60, rect.bottom - 27 - m_SplitterPos, 52, 5 + m_SplitterPos, GetColor(COL_DISABLED));
		dc.FillSolidRect(4, rect.bottom - 78 - m_SplitterPos, 6, 50 + m_SplitterPos, GetColor(COL_DISABLED));
		dc.FillSolidRect(10, rect.bottom - 78 - m_SplitterPos, rect.right - 69, 56 + m_SplitterPos, GetColor(COL_DISABLED));
	}

	DrawCorner(&dc, 0, 18, GetColor(COL_LINEFRAMES), 1, HasMessage || IsTransfering, GetColor(COL_LIGHTITEMS));
	DrawCorner(&dc, rect.right - 10, 18, GetColor(COL_LINEFRAMES), 2, HasMessage || IsTransfering, GetColor(COL_LIGHTITEMS));
	DrawCorner(&dc, 0, rect.bottom - 28, GetColor(COL_LINEFRAMES), 3, !Enabled, GetColor(COL_DISABLED));
	DrawCorner(&dc, rect.right - 10, rect.bottom - 28, GetColor(COL_LINEFRAMES), 4, !Enabled, GetColor(COL_DISABLED));
}

void CConversation::OnFileClose() 
{
	SendMessage(WM_CLOSE, 0, 0);	
}

void CConversation::OnBlock() 
{
	if (Contact->IsBlocked())
	{
		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_BLOCKTHISCONTACT, 0, (LPARAM) Contact); 	
	}
	else
	{
		if (Contact->IsTransfering())
		{
			MessageBox("You cannot block a contact with a file transfer in progress", "Block contact", MB_OK|MB_ICONSTOP);
			return;
		}
		else
		::SendMessage(GetApp()->View->GetSafeHwnd(), WM_BLOCKTHISCONTACT, 1, (LPARAM) Contact); 
	}
}

void CConversation::UpdateWindow()
{
	CHECK_WND_P(this)

	if (Contact->IsBlocked())
	{
		SetBlocked(true);
	}
	else
	{
		SetBlocked(false);
	}

	if (Contact->IsOffline())
	{
		ShowMessage("You cannot send messages to this contact because he/she is offline.");
		Disable();
	}
	else if (GetApp()->View->Me.IsOffline())
	{
		ShowMessage("You cannot send messages because you are set to 'Appear Offline'.");
		Disable();
	}
	else if (Contact->IsBlocked())
	{
		ShowMessage("You cannot send messages to this contact because you have blocked him/her.");
		Disable();
	}
	else if (Contact->IsAway())
	{
		char buf[512];
		sprintf(buf, "This contact may not reply because he/she is away (%s).", Contact->GetAwayReason());
		ShowMessage(buf);
		Enable();
	}
	else if (GetApp()->View->Me.IsAway())
	{
		ShowMessage("You are currently set to 'Away'.");
		if (!Enabled) Enable();
	}
	else
	{
		if (HasMessage) HideMessage();
		if (!Enabled) Enable();
	}
}

void CConversation::SetBlocked(bool bBlocked)
{
	CHECK_WND(m_SendFile)
	CHECK_WND(m_Block)

	if (bBlocked)
	{
		CMenu *Menu = GetMenu(), *SubMenu;
		SubMenu = Menu->GetSubMenu(1);
		SubMenu->ModifyMenu(ID_IDRCONVERSATIONMENU_BLOCK, MF_BYCOMMAND | MF_STRING, ID_IDRCONVERSATIONMENU_BLOCK, "Unblock");
		m_SendFile.EnableWindow(FALSE);
		m_Block.SetIcons(m_iUnblock);
		m_Block.SetWindowText("Unblock");
		m_Block.Invalidate();
	}
	else
	{
		CMenu *Menu = GetMenu(), *SubMenu;
		SubMenu = Menu->GetSubMenu(1);
		SubMenu->ModifyMenu(ID_IDRCONVERSATIONMENU_BLOCK, MF_BYCOMMAND | MF_STRING, ID_IDRCONVERSATIONMENU_BLOCK, "Block");
		m_SendFile.EnableWindow(TRUE);
		m_Block.SetIcons(m_iBlock);
		m_Block.SetWindowText("Block");
		m_Block.Invalidate();
	}
}

void CConversation::SetNoSend(bool bNoSend)
{
	if (bNoSend)
	{
		CMenu *Menu = GetMenu(), *SubMenu;
		SubMenu = Menu->GetSubMenu(1);
		SubMenu->EnableMenuItem(ID_IDRCONVERSATIONMENU_SENDFILE, MF_GRAYED | MF_DISABLED);
		m_SendFile.EnableWindow(FALSE);
	}
	else
	{
		CMenu *Menu = GetMenu(), *SubMenu;
		SubMenu = Menu->GetSubMenu(1);
		SubMenu->EnableMenuItem(ID_IDRCONVERSATIONMENU_SENDFILE, MF_ENABLED);
		m_SendFile.EnableWindow(TRUE);
	}
}

void CConversation::OnSendfile() 
{
	GetApp()->View->StartFileTransfer(GetSafeHwnd(), Contact, true);
}


/////////////////////// File tansfer members ///////////////////////


BOOL CConversation::InitStatus(CFileSocketThread *pThread, CContact *pContact, bool bSending, char *szFileName)
{
	char buf[512], buf2[512];

	CHECK_WND_P0(this)
	CHECK_WND0(m_Cancel)
	CHECK_WND0(m_Progress)
	CHECK_WND0(m_FileStats)
	CHECK_WND0(m_Chat)
	CHECK_WND0(m_TransferStats)

	strcpy(FileName, szFileName);

	Thread = pThread;
	Sending = bSending;

	m_Progress.SetRange(0, 100);

	HideMessage();

	IsTransfering = true;
	
	RECT rect;
	GetClientRect(&rect);

	m_Cancel.ShowWindow(SW_SHOW);
	m_Cancel.MoveWindow(220, 28, 45, 16);

	m_Progress.ShowWindow(SW_SHOW);
	m_Progress.MoveWindow(10, 29, 200, 14);
	m_Progress.SetPos(0);
	m_Progress.SetTextColor(GetColor(COL_NORMALTEXT));
	m_FileStats.ShowWindow(SW_SHOW);
	m_TransferStats.ShowWindow(SW_SHOW);

	if (rect.bottom - 198 < 40)
	{
		SetSplitterPos(m_SplitterPos - (40 - (rect.bottom - 198)));
	}

	m_bgWnd.MoveWindow(6, 82, rect.right - 10, rect.bottom - 198);

	nopath(buf, szFileName);

	sprintf(buf2, "%s: %s", Sending ? "Sending" : "Receiving", buf);

	m_FileStats.SetWindowText(buf2);
	m_TransferStats.SetWindowText("");
	m_Cancel.SetWindowText("Cancel");

	GetWindowRect(&rect);

	if (rect.right - rect.left < 300)
	{
		MoveWindow(rect.left, rect.top, 300, rect.bottom - rect.top);
	}

	if (rect.bottom - rect.top < 289)
	{
		MoveWindow(rect.left, rect.top, rect.right - rect.left, 289);
		SetSplitterPos(0);
	}

	UpdateSizes();
	RedrawEssential();

	return 1;
}

void CConversation::SetPercent(int nPercent)
{
	char buf[512], buf2[512];

	CHECK_WND_P(this)
	CHECK_WND(m_Progress)

	m_Progress.SetPos(nPercent);
	if (nPercent > 50) 
		m_Progress.SetTextColor(RGB(255, 255, 255));
	nopath(buf2, FileName);
	sprintf(buf, "Conversation: %s (%s %d%% of %s)", Contact->GetScreenName(), Sending ? "Sent" : "Received", nPercent, buf2);
	SetWindowText(buf);
}

void CConversation::SetStats(unsigned long Total, unsigned long Transfered)
{
	char buf[512], buf3[64], buf4[64];

	CHECK_WND_P(this)
	CHECK_WND(m_TransferStats)

	strcpy(buf3, FormatBytes(Total));
	strcpy(buf4, FormatBytes(Contact->Transfer->FileLen));
	sprintf(buf, "Transfer rate: %s/s %s: %s of %s", FormatBytes(Transfered), 
		Sending ? "Sent" : "Received", buf3, buf4);
	m_TransferStats.SetWindowText(buf);
}

void CConversation::SetStatus(const char *Text)
{
	char buf[512];

	CHECK_WND_P(this)
	CHECK_WND(m_FileStats)

	strcpy(buf, "Status: ");
	strcat(buf, Text);
	m_FileStats.SetWindowText(buf);
}

void CConversation::Remove()
{
	char buf[512];

	CHECK_WND_P(this)
	CHECK_WND(m_Cancel)
	CHECK_WND(m_Progress)
	CHECK_WND(m_FileStats)
	CHECK_WND(m_TransferStats)

	IsTransfering = false;
	RECT rect;
	GetClientRect(&rect);
	SendMessage(WM_PAINT, 0, 0);
	m_TransferStats.ShowWindow(SW_HIDE);
	m_FileStats.ShowWindow(SW_HIDE);
	m_Progress.ShowWindow(SW_HIDE);
	m_Cancel.ShowWindow(SW_HIDE);
	SendMessage(WM_PAINT, 0, 0);
	UpdateWindow();
	SetTimer(1, 1, 0);
	sprintf(buf, "Conversation: %s", Contact->GetScreenName());
	SetWindowText(buf);
	UpdateSizes();
	RedrawEssential();
}

void CConversation::Ended()
{
	CHECK_WND(m_Cancel)
	CHECK_WND_P(this)

	m_Cancel.SetWindowText("Close");
	m_TransferStats.SetWindowText("");
	m_Cancel.Invalidate();
}

void CConversation::OnTransferCancel() 
{
	Remove();
	if (Thread)
	Thread->Kill();	
}

///////////////////////////////////////////////////////////////////////

void CConversation::OnOK() 
{	

}

void CConversation::OnCancel() 
{

}

void CConversation::UpdateSizes()
{
	RECT clientRect;

	CHECK_WND(m_Chat)
	CHECK_WND(m_SendButton)
	CHECK_WND(m_To)
	CHECK_WND(m_SendFile)
	CHECK_WND(m_Message)
	CHECK_WND(m_TransferStats)
	CHECK_WND(m_FileStats)
	CHECK_WND(m_SendMsg)

	GetClientRect(&clientRect);

	RECT rect;

	if (HasMessage)
	{
		m_bgWnd.MoveWindow(6, 46, clientRect.right - 10, (clientRect.bottom - 162) - m_SplitterPos);
	}
	else if (IsTransfering)
	{
		m_bgWnd.MoveWindow(6, 82, clientRect.right - 10, (clientRect.bottom - 198) - m_SplitterPos);
	}
	else
	{
		m_bgWnd.MoveWindow(6, 30, clientRect.right - 10, (clientRect.bottom  - 146) - m_SplitterPos);
	}

	if (IsTransfering)
	{
		m_FileStats.MoveWindow(10, 46, clientRect.right - 20, 14);
		m_TransferStats.MoveWindow(10, 64, clientRect.right - 20, 14);
	}

	m_Chat.GetClientRect(&rect);
	if (rect.bottom < 40)
	{
		if (clientRect.bottom > 0)
		SetSplitterPos(m_SplitterPos - (40 - rect.bottom));
	}

	m_SendMsg.MoveWindow(6, (clientRect.bottom - 78) - m_SplitterPos, clientRect.right - 73, 54 + m_SplitterPos);
	m_SendButton.MoveWindow(clientRect.right - 60, (clientRect.bottom - 72) - m_SplitterPos, 52, 45);
	m_To.MoveWindow(6, 4, clientRect.right - 6, 18);
	m_Message.MoveWindow(10, 28, clientRect.right - 20, 18);
	m_Block.MoveWindow(clientRect.right - 84, (clientRect.bottom - 116) - m_SplitterPos, 80, 34);
	m_SendFile.MoveWindow(clientRect.right - 169, (clientRect.bottom - 116) - m_SplitterPos, 85, 34);
	m_Splitter.MoveWindow(4, (clientRect.bottom - 82) - m_SplitterPos, clientRect.right - 8, 4);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	m_Block.Invalidate();
	m_SendFile.Invalidate();
}

void CConversation::ColorUpdate()
{
	m_Message.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));
	m_Progress.SetBkColor(GetColor(COL_LIGHTITEMS));
	m_To.SetColors(GetColor(COL_NOTIFYTEXT), GetColor(COL_LINEFRAMES));
	m_Progress.SetTextColor(GetColor(COL_NORMALTEXT));
	m_TransferStats.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));
	m_FileStats.SetColors(GetColor(COL_NORMALTEXT), GetColor(COL_LIGHTITEMS));

	BrushNormal.DeleteObject();
	BrushLight.DeleteObject();
	BrushDisabled.DeleteObject();

	BrushNormal.CreateSolidBrush(GetColor(COL_LINEFRAMES));
	BrushLight.CreateSolidBrush(GetColor(COL_LIGHTITEMS));
	BrushDisabled.CreateSolidBrush(GetColor(COL_DISABLED));

	RedrawWindow();
}

void CConversation::RedrawEssential()
{
	CRect rect;
	CRect rcUpdate;
	GetClientRect(rect);
	rcUpdate.SetRect(0, 18, rect.right, rect.bottom - 18);
	RedrawWindow(&rcUpdate);
}

void CConversation::PrepareHtmlHelp()
{
	POSITION pos;
	char szTempPath[1024];
	char szFilePath[1024];
	char cwd[1024];

	CList<EMOTICON *, EMOTICON *> &Emoticons = GetApp()->View->Emoticons;
	FILE *f;

	::GetTempPath(sizeof(szTempPath), szTempPath);
	getcwd(cwd, sizeof(cwd));
	sprintf(szFilePath, "%spre%u.htm", szTempPath, GetVersion());
	f = fopen(szFilePath, "w");
	if (!f)
	{
		MessageBox("There was an error while attempting to write out the help file", "Error", MB_ICONSTOP|MB_OK);
		return;
	}
	fprintf(f,

	"<html>\r\n"
	"<head>\r\n"
	"<title>Network Messenger Emoticons Help</title>\r\n"
	"</head>\r\n"
	"<body>\r\n"
	"<font face=\"verdana, arial, helvetica\" size=\"2\">\r\n"
	"Below is a list of emoticons currently loaded into Network Messenger.<br>\r\n"
	"Type the text in the 'Text' Column and it will be replaced with the associated emoticon.<br><br>\r\n"
	"Emoticons can be added/removed in emoticons.ini.<br><br>\r\n"
	"</font>\r\n"
	"<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" align=\"left\">\r\n"
	"<tr>\r\n"
	"<td><p align=\"center\"><font face=\"verdana, arial, helvetica\" size=\"2\">&nbsp;Text&nbsp;</font></p></td>\r\n"
	"<td><p align=\"center\"><font face=\"verdana, arial, helvetica\" size=\"2\">&nbsp;Emoticon&nbsp;</font></p></td>\r\n"
	"</tr>\r\n"

	);

	pos = Emoticons.GetHeadPosition();
	while (pos)
	{
		EMOTICON *Emoticon = Emoticons.GetNext(pos);
		fprintf(f, 

		"<tr>\r\n"
		"<td><p align=\"center\"><font face=\"verdana, arial, helvetica\" size=\"2\">%s</font></p></td>\r\n"
		"<td><p align=\"center\"><img src=\"file:///%s\\%s\"></p></td>\r\n"
		"</tr>\r\n",

		Emoticon->szActivationText, cwd, Emoticon->szFileName);
	}
	fprintf(f, 

	"</table>\r\n"
	"</body>\r\n"
	"</html>\r\n"
	);

	fclose(f);
	ShellExecute(GetSafeHwnd(), "OPEN", szFilePath, NULL, NULL, SW_SHOW);
}

void CConversation::OnHelpEmoticonshelp() 
{
	PrepareHtmlHelp();	
}
