#include "Contact.h"

struct PLUGIN
{
	char filename[1024];
	unsigned int TimerId;
	HINSTANCE hHandle;
};

typedef BOOL (__stdcall *T_INITPLUGIN)(HINSTANCE, int, BYTE);
typedef void (__stdcall *T_FUNCVOID)(void);
typedef void (__stdcall *T_FUNCINT)(int);
typedef void (__stdcall *T_FUNCCHAR)(char *);
typedef void (__stdcall *T_FUNCVOIDPTR)(void *);
typedef void (__stdcall *T_FUNCSTATUS)(void *, unsigned long);
typedef void (__stdcall *T_MESSAGE)(char *, char *);
typedef void (__stdcall *T_TIMER)(BYTE);
typedef void (__stdcall *T_MESSAGESEND)(char *, char *);


#define CT_ONLINE 0x1
#define CT_OFFLINE 0x2
#define CT_AWAY 0x4
#define CT_NAME 0x8
#define CT_BLOCK 0x10
#define CT_FONT 0x20

struct CONTACT
{
	char ip[16];
	char screenname[64];
	char awayreason[256];
	int flags;
	USERFONT font;
};

void LoadPlugins();
void PluginsNotifyContactsConnected();
void PluginsApplicationExit();
void PluginsContactAdded(CContact *);
void PluginsContactDeleted(CContact *);
void PluginsContactStatusChanged(CContact *, unsigned long);
void PluginsConversationWindowOpened(CContact *);
void PluginsMessageReceived(CContact *, char *);
void PluginsTimer(unsigned int);
void PluginsMessageSent(CContact *, char *);