#include "stdafx.h"
#include "Externals.h"

CList <CONTACT *, CONTACT *> Contacts;

HINSTANCE hIns;
BYTE nPluginID = 0;

void ExtInitPlugin(HINSTANCE hModule, BYTE ID)
{
	hIns = hModule;
	nPluginID = ID;
}

void ExtContactStatusChanged(CONTACT *extContact)
{
	POSITION pos;
	pos = Contacts.GetHeadPosition();
	while (pos)
	{
		CONTACT *Contact = Contacts.GetNext(pos);
		if (!strcmp(extContact->ip, Contact->ip))
		{
			NMGetContactInfo(extContact->ip, Contact);
		}
	}
}

void ExtContactAdded(CONTACT *Contact)
{
	CONTACT *NewContact = new CONTACT;
	NMGetContactInfo(Contact->ip, NewContact);
	Contacts.AddTail(NewContact);
}

void ExtContactDeleted(char *Ip)
{
	POSITION pos;
	pos = Contacts.GetHeadPosition();
	while (pos)
	{
		CONTACT *Contact = Contacts.GetNext(pos);
		if (!strcmp(Contact->ip, Ip))
		{
			Contacts.RemoveAt(Contacts.Find(Contact));
			delete Contact;
		}
	}
}

void ExtApplicationExit()
{
	POSITION pos;
	pos = Contacts.GetHeadPosition();
	while (pos)
	{
		CONTACT *Contact = Contacts.GetNext(pos);
		Contacts.RemoveAt(Contacts.Find(Contact));
		delete Contact;
	}
}

CONTACT *FindContact(char *Ip)
{
	POSITION pos;
	pos = Contacts.GetHeadPosition();
	while (pos)
	{
		CONTACT *Contact = Contacts.GetNext(pos);
		if (!strcmp(Ip, Contact->ip))
		return Contact;
	}
	return NULL;
}

unsigned int NMAppendMainMenu(int whichMenu, int nMenu, char *szText, void (__stdcall *lpfn)(void))
{
	T_APPENDMAINMENU func;
	func = (T_APPENDMAINMENU)GetProcAddress(hIns, "NMAppendMainMenu");
	if (!func) return 0;
	return func(whichMenu, nMenu, szText, lpfn);
}

BOOL NMDeleteMainMenu(int whichMenu, int nMenu, unsigned int nItem)
{
	T_DELETEMENU func;
	func = (T_DELETEMENU)GetProcAddress(hIns, "NMDeleteMainMenu");
	if (!func) return 0;
	return func(whichMenu, nMenu, nItem);
}

BOOL NMSendMessage(char *Ip, char *Message)
{
	T_SENDMESSAGE func;
	func = (T_SENDMESSAGE)GetProcAddress(hIns, "NMSendMessage");
	if (!func) return FALSE;
	return func(Ip, Message);
}

BOOL NMGetSelectedContact(CONTACT *extContact)
{
	T_GETSELECTED func;
	func = (T_GETSELECTED)GetProcAddress(hIns, "NMGetSelectedContact");
	if (!func) return FALSE;
	return func(extContact);
}

BOOL NMGetContactInfo(char *Ip, CONTACT *extContact)
{
	T_GETINFO func;
	func = (T_GETINFO)GetProcAddress(hIns, "NMGetContactInfo");
	if (!func) return FALSE;
	return func(Ip, extContact);
}

void NMSetScreenName(char *szNewName)
{
	T_SETNAME func;
	func = (T_SETNAME)GetProcAddress(hIns, "NMSetScreenName");
	if (!func) return;
	func(szNewName);
}

void NMSetAway(bool bAway, char *szReason)
{
	T_SETAWAY func;
	func = (T_SETAWAY)GetProcAddress(hIns, "NMSetAway");
	if (!func) return;
	func(bAway, szReason);
}

void NMSetOffline(bool bOffline)
{
	T_SETOFFLINE func;
	func = (T_SETOFFLINE)GetProcAddress(hIns, "NMSetOffline");
	if (!func) return;
	func(bOffline);
}

void NMSetTimer(BYTE nIDEvent, unsigned int nElapse)
{
	T_SETTIMER func;
	func = (T_SETTIMER)GetProcAddress(hIns, "NMSetTimer");
	if (!func) return;
	func(nPluginID, nIDEvent, nElapse);
}

HWND NMGetHwnd()
{
	T_GETHWND func;
	func = (T_GETHWND)GetProcAddress(hIns, "NMGetHwnd");
	if (!func) return NULL;
	return func();
}
