//Externals.h

struct USERFONT
{
	LOGFONT lfFont;
	COLORREF crColor;
	int nPointSize;
};

struct CONTACT
{
	char ip[16];
	char screenname[64];
	char awayreason[256];
	int flags;
	USERFONT font;
};

void ExtContactStatusChanged(CONTACT *);
void ExtInitPlugin(HINSTANCE, BYTE);
void ExtContactAdded(CONTACT *);
void ExtContactDeleted(char *);
void ExtApplicationExit();

CONTACT *FindContact(char *Ip);

/* Netmsg functions */

BOOL NMSendMessage(char *Ip, char *Message);
unsigned int NMAppendMainMenu(int whichMenu, int nMenu, char *szText, void (__stdcall *lpfn)(void));
void NMSetScreenName(char *szNewName);
void NMSetAway(bool bAway, char *szReason);
void NMSetOffline(bool bOffline);
BOOL NMGetSelectedContact(CONTACT *);
BOOL NMGetContactInfo(char *Ip, CONTACT *);
BOOL NMDeleteMainMenu(int, int, unsigned int);
void NMSetTimer(BYTE, unsigned int);
HWND NMGetHwnd();

typedef UINT (__stdcall *T_APPENDMAINMENU)(int, int, char *, void (__stdcall *)(void));
typedef BOOL (__stdcall *T_SENDMESSAGE)(char *, char *);
typedef BOOL (__stdcall *T_GETCONTACT)(CONTACT *);
typedef BOOL (__stdcall *T_CONTACTINFO)(char *, CONTACT *);
typedef void (__stdcall *T_SETNAME)(char *);
typedef void (__stdcall *T_SETAWAY)(bool, char *);
typedef void (__stdcall *T_SETOFFLINE)(bool);
typedef BOOL (__stdcall *T_GETSELECTED)(CONTACT *);
typedef BOOL (__stdcall *T_GETINFO)(char *, CONTACT *);
typedef BOOL (__stdcall *T_DELETEMENU)(int, int, unsigned int);
typedef void (__stdcall *T_SETTIMER)(BYTE, BYTE, unsigned int);
typedef HWND (__stdcall *T_GETHWND)(void);


#define AM_RIGHTCLICK 0
#define AM_RIGHTCLICKME 1
#define AM_MAIN 2

#define AM_FILE 0
#define AM_ACTIONS 1
#define AM_STATUS 2
#define AM_TOOLS 3
#define AM_HELP 4

#define CT_ONLINE 0x1
#define CT_OFFLINE 0x2
#define CT_AWAY 0x4
#define CT_NAME 0x8
#define CT_BLOCK 0x10
#define CT_FONT 0x20

#define CFL_OFFLINE			0x01
#define CFL_ONLINE			0x02
#define CFL_AWAY			0x04
#define CFL_AUTHENTICATE_NO 0x08
#define CFL_BLOCKED			0x10
#define CFL_ACTIVE			0x20
#define CFL_TRANSFER		0x40
#define CFL_DLGCREATED		0x80
