// NetmsgView.h : interface of the CNetmsgView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETMSGVIEW_H__AF92ACD6_5C87_41CE_978F_A5FE95782B87__INCLUDED_)
#define AFX_NETMSGVIEW_H__AF92ACD6_5C87_41CE_978F_A5FE95782B87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ContactView.h"
#include "NetmsgDoc.h"
#include "MibAccess.h"
#include "CornerStatic.h"
#include "TrackLookButton.h"
#include "ColorStatic.h"
#include "ReturnEdit.h"

class CListenSocket;

#define CONTACT_LIST 0x3E5F

class CNetmsgView : public CView
{
protected: // create from serialization only
	CNetmsgView();
	DECLARE_DYNCREATE(CNetmsgView)
	CContactView ContactList;

// Attributes
public:
	CNetmsgDoc* GetDocument();

// Operations
public:

	CTrackLookButton OK;
	CReturnEdit MessageInput;
	CColorStatic MessageText;
	CFont FontNormal;
	CBrush BrushNormal;
	CBrush BrushLight;

	void Destroy();
	tSTRUCTNICINFO *pNICInfo;
	int NICCount;
	int nMessage;
	bool HasMessage;
	bool IsMyIp(IP Ip);
	void PrepareMessage(bool, int);
	void OnMessageOK();
	void ColorUpdate();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNetmsgView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CNetmsgView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CNetmsgView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in NetmsgView.cpp
inline CNetmsgDoc* CNetmsgView::GetDocument()
   { return (CNetmsgDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NETMSGVIEW_H__AF92ACD6_5C87_41CE_978F_A5FE95782B87__INCLUDED_)
