// netmsgdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "netmsgdll.h"
#include "Externals.h"
#include "OptionsPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CNetmsgdllApp

BEGIN_MESSAGE_MAP(CNetmsgdllApp, CWinApp)
	//{{AFX_MSG_MAP(CNetmsgdllApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetmsgdllApp construction

CNetmsgdllApp::CNetmsgdllApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

CNetmsgdllApp::~CNetmsgdllApp()
{
}

BOOL CNetmsgdllApp::InitInstance() 
{
	SetRegistryKey("Netmsg");

	return CWinApp::InitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNetmsgdllApp object

CNetmsgdllApp theApp;

COptionsPage *Options;

BOOL __stdcall NMInitPlugin(HINSTANCE hModule, int nVer, BYTE nPluginIndex)
{
	ExtInitPlugin(hModule, nPluginIndex);
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	Options = new COptionsPage();

	//extra init code here.

	return TRUE; //FALSE to not load this DLL.
}

void __stdcall NMContactsConnected()
{
	//called every time program completed contact connections.
}

void __stdcall NMApplicationExit()
{
	ExtApplicationExit();
	delete Options;

	//called when the application is exiting.
	//library will be unloaded immediatly after this call
}

void __stdcall NMContactAdded(CONTACT *Contact)
{
	ExtContactAdded(Contact);

	//called when a new contact is added.
	//pointer sent is to a static structure.
}

void __stdcall NMContactDeleted(char *Ip)
{
	ExtContactDeleted(Ip);

	//called when a contact is deleted.
	//IP address of contact is sent.
}

void __stdcall NMContactStatusChanged(CONTACT *extContact, unsigned long Mask)
{
	ExtContactStatusChanged(extContact);

	//called when the status/font/name of a user changes.
	//mask specifies what has changed, see CT_ in Externals.h.

	//the buffer from extContact is STATIC! i.e. next time it's
	//going to be the same buffer with different contents
	//use FindContact(extContact->ip) to get a dynamic buffer
}

void __stdcall NMConversationWindowOpened(char *Ip)
{
	//called when a conversation window is opened to the contact.
}

void __stdcall NMMessageReceived(char *Ip, char *Message)
{
	//called just before an incoming message is displayed.
	//buffer may be modified but cannot exceed original length.
}

void __stdcall NMTimer(BYTE nIDEvent)
{
	//called whever a timer is triggered 
	//nIDEvent is what was specified with NMSetTimer()
}

void __stdcall NMMessageSend(char *Ip, char *Message)
{
	//called before messages are sent 
	//buffer can be modified to send a different message
	//hint: don't exceed 1024 bytes in length :P
}

CPropertyPage *__stdcall NMGetPropertyPage()
{
	//Netmsg will call this to get the address of the property page for this DLL
	//constructed in NMInitPlugin()
	//return NULL for no property page
	//the property page will appear in the Options dialog.

	return Options;
}


/*
	brief description of functions available to call Netmsg
	
	BOOL NMSendMessage(char *Ip, char *Message)

	Sends a message to a contact with that IP address

	unsigned int NMAppendMainMenu(int whichMenu, int nMenu, char *szText, void (__stdcall *lpfn)(void));

	Appends an item to a menu in netmsg

	whichMenu
	AM_RIGHTCLICK
	AM_RIGHTCLICKME
	AM_MAIN

	if using AM_MAIN the following propertied can be used in nMenu
	AM_FILE
	AM_ACTIONS
	AM_STATUS
	AM_TOOLS
	AM_HELP

	lpfn should be a pointer to a callback function when the menu is clicked i.e.

	this will return an ID for the menu item created. use then when calling NMDeleteMainMenu()

	void __stdcall menucallback()

	void NMSetScreenName(char *szNewName)

	change your screen name

	void NMSetAway(bool bAway, char *szReason)

	set you away of online with reason

	void NMSetOffline(bool bOffline)
	
	set appear offline status to yourself true/false

	BOOL NMGetSelectedContact(CONTACT *)

	get the contact selected in the list view

	BOOL NMGetContactInfo(char *Ip, CONTACT *)

	get contact info by ip address buffer for contact should be specified

	BOOL NMDeleteMainMenu(int whichMenu, int nMenu, unsigned int nItem)

	delete an item from the menu

	void NMSetTimer(BYTE nID, unsigned int)
	
	set a timer with the specified ID

	HWND NMGetHwnd()

	return Netmsg's main handle

*/
